#ifndef ADMFS_RUNTIME_INFO_HH__
#define ADMFS_RUNTIME_INFO_HH__

#include <vector>
#include <string>
#include <map>

typedef std::map<std::string,std::string> cache_type;

struct runtime_info
{
    runtime_info():
	opened_(false),
	open_mode_(0)
    {}
    bool opened_;
    int open_mode_;
    std::vector<char> buffer_; /**< file content: result of reading from subprocess stdout */
    std::vector<char> err_buffer_; /**< .err file content: result of reading from subprocess stderr */
    cache_type cache_; /**< dir content cache */
};

#endif
